
#include <LiquidCrystal.h>
#include <SoftwareSerial.h>

SoftwareSerial sSerial(4, 5); // RX, TX
LiquidCrystal lcd(12, 11, 10,9,8,7);
//LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

void setup() 
{
sSerial.begin(9600);
lcd.begin(20,4);     
lcd.clear();
lcd.setCursor(0,0);lcd.print("Serial -> LCD");
lcd.setCursor(0,1);lcd.print("pin D4 for RX");
lcd.setCursor(0,2);lcd.print("9600 baud");
lcd.setCursor(0,3);lcd.print("$,~ ctl");
}

void loop() 
{
 int c;
 while (sSerial.available())
    {
      c = sSerial.read();
      if (c == '~')
        {
          while (!sSerial.available())
            ;
          c = sSerial.read();
          //Serial.print(" got ~ command  ");Serial.write(c);Serial.println();
          if (c == 'c')
            {
              //Serial.println(" clearing LCD ..");
              lcd.clear();
            }
          else
            lcd.setCursor(0,c - '0');
        }
      else if (c == '$')
        lcd.setCursor(0,0);
        
      else if (c != '$' && c != '~')
        lcd.write(c);
    }

}
